From ad3dbdc535c7195c54fa0d5eca325135da9149bd Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Aug 31 2020 08:01:39 +0000
Subject: [PATCH 784/2232] Avoid bumping modified time of existing up to date files


---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index afbcbe1..001f346 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -109,9 +109,7 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
 
 fn write_header() -> Result<()> {
     let ref cxx_h = paths::include_dir()?.join("rust").join("cxx.h");
-    let _ = fs::create_dir_all(cxx_h.parent().unwrap());
-    let _ = fs::remove_file(cxx_h);
-    let _ = fs::write(cxx_h, gen::include::HEADER);
+    let _ = write(cxx_h, gen::include::HEADER.as_bytes());
     Ok(())
 }
 
@@ -121,11 +119,27 @@ fn generate_bridge(build: &mut Build, rust_source_file: &Path) -> Result<()> {
 
     let header_path = paths::out_with_extension(rust_source_file, ".h")?;
     fs::create_dir_all(header_path.parent().unwrap())?;
-    fs::write(&header_path, generated.header)?;
+    write(&header_path, &generated.header)?;
     paths::symlink_header(&header_path, rust_source_file);
 
     let implementation_path = paths::out_with_extension(rust_source_file, ".cc")?;
-    fs::write(&implementation_path, generated.implementation)?;
+    write(&implementation_path, &generated.implementation)?;
     build.file(&implementation_path);
     Ok(())
 }
+
+fn write(path: &Path, content: &[u8]) -> Result<()> {
+    if path.exists() {
+        if let Ok(existing) = fs::read(path) {
+            if existing == content {
+                // Avoid bumping modified time with unchanged contents.
+                return Ok(());
+            }
+        }
+        let _ = fs::remove_file(path);
+    } else {
+        let _ = fs::create_dir_all(path.parent().unwrap());
+    }
+    fs::write(path, content)?;
+    Ok(())
+}

